import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';

class BloxImageView extends StatefulWidget {
  final String imageUrl;
  final Function(String url, String heroTag) onTap;

  const BloxImageView({Key key, this.imageUrl, this.onTap}) : super(key: key);

  @override
  _BloxImageViewState createState() => _BloxImageViewState();
}

class _BloxImageViewState extends State<BloxImageView> {
  String heroTag;
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Column(children: [
      MouseRegion(
        child: GestureDetector(
          onTap: () {
            if (widget.onTap != null) widget.onTap(widget.imageUrl, heroTag);
          },
          child: Image.network(
            widget.imageUrl,
            frameBuilder: (context, child, frame, wasSynchronouslyLoaded) {
              return Container(
                padding: EdgeInsets.all(8),
                decoration: BoxDecoration(
                    color: Colors.transparent,
                    borderRadius: BorderRadius.circular(8),
                    boxShadow: [
                      BoxShadow(
                          color: Colors.black12,
                          blurRadius: 10,
                          spreadRadius: 1)
                    ]),
                child: ClipRRect(
                    borderRadius: BorderRadius.circular(8), child: child),
              );
            },
            loadingBuilder: (context, child, loadingProgress) {
              if (loadingProgress == null) {
                return child;
              } else {
                return Center(
                  child: CircularProgressIndicator(
                    value: loadingProgress.expectedTotalBytes != null
                        ? loadingProgress.cumulativeBytesLoaded /
                            loadingProgress.expectedTotalBytes
                        : null,
                  ),
                );
              }
            },
            height: 250,
          ),
        ),
      ),
      SizedBox(
        height: 16,
      ),
    ]);
  }
}
