import 'package:blox/models/text_block_attr.dart';
import 'package:blox/widgets/blocks/text_editor.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/rendering.dart';

class BloxTextView extends StatelessWidget {
  final String text;
  final bool multiLine;
  final TextStyle style;
  final TextBlockAlign align;
  final Function(String text) onTap;

  const BloxTextView(
      {Key key,
      this.text,
      this.multiLine,
      this.style,
      this.onTap,
       this.align})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return MouseRegion(
//      cursor:
//          onTap != null ? SystemMouseCursors.click : SystemMouseCursors.basic,
      child: GestureDetector(
        onTap: () {
          if (onTap != null) onTap(text);
        },
        child: Container(
          padding: EdgeInsets.all(8),
          child: Text(
            text,
            textDirection: isRTL(text) ? TextDirection.rtl : TextDirection.ltr,
            textAlign: getTextAlign(align, text),
            style: style,
          ),
        ),
      ),
    );
  }

  getTextAlign(align, text) {
    switch (align) {
      case TextBlockAlign.auto:
        return isRTL(text) ? TextAlign.right : TextAlign.left;
        break;
      case TextBlockAlign.center:
        return TextAlign.center;
        break;
      case TextBlockAlign.left:
        return TextAlign.left;
        break;
      case TextBlockAlign.right:
        return TextAlign.right;
        break;
    }
  }
}
